﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfApplication1.Models;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Person> People;

        Person CurrentPerson;

        public MainWindow()
        {
            InitializeComponent();

            initData();
        }

        private void initData()
        {
            People = new ObservableCollection<Person>
            {
                new Person{ Id=0 , Age=11 , Name="kaki104" , Sex=true},
                new Person{ Id=1 , Age=22 , Name="kakao" , Sex=false},
                new Person{ Id=2 , Age=33 , Name="kass" , Sex=true},
                new Person{ Id=3 , Age=44 , Name="kameo" , Sex=false},
                new Person{ Id=4 , Age=55 , Name="keroro" , Sex=true}
            };
            CurrentPerson = People.FirstOrDefault();

            lbPeople.ItemsSource = People;
            displayCurrentPerson();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            //Set Current
            CurrentPerson = lbPeople.SelectedItem as Person;
            displayCurrentPerson();
        }

        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            //Add Person
            CurrentPerson = new Person();
            CurrentPerson.Id = People.Max(p => p.Id) + 1;
            People.Add(CurrentPerson);
            displayCurrentPerson();
        }

        private void Button_Click_3(object sender, RoutedEventArgs e)
        {
            //Remove Person
            if (CurrentPerson != null && People.Count(p => p.Id == CurrentPerson.Id) > 0)
            {
                People.Remove(CurrentPerson);
                CurrentPerson = null;
                displayCurrentPerson();
            }
        }

        private void displayCurrentPerson()
        {
            if (CurrentPerson != null)
            {
                tbId.Text = CurrentPerson.Id.ToString();
                tbAge.Text = CurrentPerson.Age.ToString();
                tbName.Text = CurrentPerson.Name;
                cbSex.IsChecked = CurrentPerson.Sex;
            }
            else
            {
                tbId.Text = "";
                tbAge.Text = "";
                tbName.Text = "";
                cbSex.IsChecked = null;
            }
        }

        private void tbAge_LostFocus(object sender, RoutedEventArgs e)
        {
            CurrentPerson.Age = Convert.ToInt32(tbAge.Text);
        }

        private void tbName_LostFocus(object sender, RoutedEventArgs e)
        {
            CurrentPerson.Name = tbName.Text;
        }

        private void cbSex_LostFocus(object sender, RoutedEventArgs e)
        {
            CurrentPerson.Sex = (cbSex.IsChecked == null || cbSex.IsChecked == false) ? false:true;
        }
    }
}
