﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace WpfApplication1.Models
{
    public class Person : INotifyPropertyChanged 
    {
        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private int id;
        /// <summary>
        /// Id
        /// </summary>
        public int Id
        {
            get { return id; }
            set 
            { 
                id = value;
                RaisePropertyChanged("Id");
            }
        }

        private int age;
        /// <summary>
        /// age
        /// </summary>
        public int Age
        {
            get { return age; }
            set 
            { 
                age = value;
                RaisePropertyChanged("Age");
            }
        }

        private string name;
        /// <summary>
        /// name
        /// </summary>
        public string Name
        {
            get { return name; }
            set 
            { 
                name = value;
                RaisePropertyChanged("Name");
            }
        }

        private bool sex;
        /// <summary>
        /// sex
        /// </summary>
        public bool Sex
        {
            get { return sex; }
            set 
            { 
                sex = value;
                RaisePropertyChanged("Sex");
            }
        }
    }
}
